package com.dsic.gj_erp.controller.jcsj;

import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jcsj.vo.BomVO;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import com.dsic.gj_erp.service.jcsj.impl.BomUploadServiceImpl;
import com.dsic.gj_erp.service.sy.SYService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@RestController
@RequestMapping("/dmBom")
public class DmBomController {

    @Autowired
    DmBomService dmBomService;

    @Autowired
    BomUploadServiceImpl bomUploadService;
    @Autowired
    SYService syService;

    @PostMapping("/getListBom")
        public ResultBean getListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
            List<BomVO> listBom = dmBomService.getListBom(req,map);

//        String id = syService.f_getpjh("DM", "SYSTEM", "BCHX");
//        String id1= syService.f_getpjh("DM", "SYSTEM", "CLDE");
//        System.out.println("id = " + id);
//        System.out.println("id = " + id1);
//            return  new ResultBean(listBom);
            return  new ResultBean(listBom);
        }
    @PostMapping("/getListBomRealy")
    public ResultBean getListBomRealy(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<DmBom> listBom = dmBomService.getListBomRealy(req,map);
        return  new ResultBean(listBom);
    }

    @PostMapping("/addListBom")
    @AuthFunction
    public ResultBean addListBom(HttpServletRequest req, @RequestBody Map map) throws CustomException {
        List<BomVO> dmBoms = bomUploadService.insertBom(req,(String) map.get("dcch"), (String) map.get("dcpl"),"02");
//       dmBomService.insertBoms(dmBoms);
        return  new ResultBean(dmBoms);
    }


    @PostMapping("/saveListBom")
    public ResultBean saveListBom(HttpServletRequest req, @RequestBody List<BomVO> list) throws CustomException {
        bomUploadService.saveBom(req,list,"","",null);
//
        return  new ResultBean();
//        return null;
    }


    @PostMapping("/copyListBom")
    public ResultBean copyListBom(HttpServletRequest req, @RequestBody Map  map) throws CustomException {
        dmBomService.copyListBom(req,map);
//
        return  new ResultBean();
//        return null;
    }

}

