package com.dsic.gj_erp.controller.jhgk;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmDhqdp;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.service.jhgk.DmDhqdpService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/dmDhqdp")
@Api(tags = "订货清单计划")
public class DmDhqdpController {
    @Autowired
    DmDhqdpService dmDhqdpService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<DmDhqdp> dmZrcjhs= dmDhqdpService.getList(json);
        return new ResultBean(dmZrcjhs);
    }

    @ApiOperation(value = "导入excel")
    @PostMapping(value = "/upload")
    public ResultBean upload(@RequestParam(value = "file") MultipartFile file) throws IOException {
        List<DmDhqdp> dmZrcjhs= dmDhqdpService.upload(file);
        return new ResultBean(dmZrcjhs);
    }

    @ApiOperation(value = "批量保存")
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody List<DmDhqdp> dmDhqdps) {
        dmDhqdpService.save(dmDhqdps);
        return new ResultBean();
    }

    @ApiOperation(value = "批量提交")
    @PostMapping(value = "/tj")
    public ResultBean tj(@RequestBody List<DmDhqdp> dmZrcjhs) {
        dmDhqdpService.tj(dmZrcjhs);
        return new ResultBean();
    }

    @ApiOperation(value = "批量审核")
    @PostMapping(value = "/sh")
    public ResultBean sh(@RequestBody List<DmDhqdp> dmZrcjhs) {
        dmDhqdpService.sh(dmZrcjhs);
        return new ResultBean();
    }

}

