package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.sy.SYService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@RestController
@RequestMapping("/dmSygdMx")
public class DmSygdMxController {

    @Autowired
    private DmSygdMxService service;
    @Autowired
    private EmSbcnpService emSbcnpService;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmSygdMx sygd){
       List<DmSygdMx> list= service.list(new QueryWrapper<DmSygdMx>()
               .eq(StrUtil.isNotEmpty(sygd.getDcCh()),"dc_ch",sygd.getDcCh())
               .eq(StrUtil.isNotEmpty(sygd.getDcPl()),"dc_pl",sygd.getDcPl())
               .ge(StrUtil.isNotEmpty(sygd.getBeginTime()),"jssj",sygd.getBeginTime())
               .le(StrUtil.isNotEmpty(sygd.getEndTime()),"jssj",sygd.getEndTime())
                       .orderByAsc("jssj,dc_ch,dc_pl")
                );
        return new ResultBean(list);
    }

    @RequestMapping("/saveByDcch")
    @AuthFunction
    public ResultBean saveByDcch(@RequestBody HashMap<String, List<Object>> map ){
        return new ResultBean(service.saveByDcch(map));
    }

    @RequestMapping("/symxhz")
    @AuthFunction
    public ResultBean symxhz(@RequestBody List<DmSygdMx> list){
        Map<String,Object> map=new HashMap<>();

        map.put("xbList",service.getXBList(list));
        map.put("plList",service.getPl(list));
        map.put("tzList",service.getTZList(list));
        map.put("dhList",service.getDhList(list));
        map.put("kwList",service.getKwList(list));
        return new ResultBean(map);
    }
    @RequestMapping("/getCnsb")
    @AuthFunction
    public ResultBean getCnsb(){
       List<EmSbcnp> list= emSbcnpService.list();
       Map<String,List<EmSbcnp>> map= list.stream().filter(l -> Objects.nonNull(l.getGx())).collect(Collectors.groupingBy(EmSbcnp::getGx));
       return new ResultBean(map);
    }
    @RequestMapping("/sygdPC")
    @AuthFunction
    public ResultBean sygdPC(){
        return new ResultBean(service.sygdPC());
    }

    @RequestMapping("/saveList")
    @AuthFunction
    public ResultBean saveList( @RequestBody List<DmSygdMx> list ){
        service.saveBatch(list);
        //TODO 重新排产
        return new ResultBean();
    }

    @RequestMapping("/tqSygd")
    @AuthFunction
    public ResultBean tqSygd( ){
        return service.tqSygd();
    }
}

