package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel1;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelGdxq1Listener;
import com.dsic.gj_erp.listeners.ExcelGdxqListener;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.spring.web.json.Json;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@RestController
@RequestMapping("/dmSygdxq")
public class DmSygdxqController {

    @Autowired
    private DmSygdxqService service;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody Map<String, String> map) {
        List<DmSygdxq> list = service.list(new QueryWrapper<DmSygdxq>()
                .ge(StrUtil.isNotEmpty(map.get("beginTime")), "xzglxq", map.get("beginTime"))
                .le(StrUtil.isNotEmpty(map.get("endTime")), "xzglxq", map.get("endTime"))
                .orderByAsc("dc_ch, cast(dc_pl as int),xzglxq"));
        if (ObjUtil.isEmpty(list)) {
            return new ResultBean();
        }
//        Map<String, List<DmSygdxq>> groupByZl = list.stream().collect(Collectors.groupingBy(DmSygdxq::getZl));

        Map<String, Map<String, Double>> m =
                list.stream()
                        .filter(x -> Objects.nonNull(x.getXzglxq()) && Objects.nonNull(x.getDzjz()))
                        .collect(Collectors.groupingBy(DmSygdxq::getDcCh
                                , Collectors.groupingBy(x -> x.getXzglxq().substring(5, 7)
                                        , Collectors.summingDouble(l -> l.getDzjz())
                                )));

        List<Json> list1 = new ArrayList<>();
        for (String ch : m.keySet()) {
            String str = "\"dcCh\":" +"\"" +ch+"\"" ;
            for (String month : m.get(ch).keySet()) {
                str += ",\"yf" + month + "\":\"" + m.get(ch).get(month)+"\"";
            }
            str = "{" + str + "}";
            Json j = new Json(str);
            list1.add(j);
        }
        Map map1 = new HashMap();
        map1.put("hz", list1);
        map1.put("list", list);
        return new ResultBean(map1);
    }

    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadQf(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws Exception, CustomException {

        ExcelGdxqListener objectListener = new ExcelGdxqListener();
        ExcelGdxq1Listener objectListener1 = new ExcelGdxq1Listener();

        EasyExcel.read(file.getInputStream(), GdxqExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<GdxqExcel> objList = objectListener.getObjectList();

        EasyExcel.read(file.getInputStream(), GdxqExcel1.class, objectListener1).sheet(1).headRowNumber(1).doRead();
        List<GdxqExcel1> objList1 = objectListener1.getObjectList();
        List<DmSygdxq> list = BeanUtil.copyToList(objList, DmSygdxq.class);
        List<DmSygdxq> list1 = BeanUtil.copyToList(objList1, DmSygdxq.class);
        String username=(String) req.getAttribute("yhms");
        String day=DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        service.saveXzList(list,username,day);
        service.saveDzList(list1,username,day);



        return new ResultBean();
    }

    public static void main(String[] agrs) {
//        String a = "2023/08/20";
//        String b = "2023/08/21";
//        System.out.println(a.compareTo(b));
        System.out.println(DateUtil.format(DateUtil.nextMonth(),"yyyy/MM"));
//        String[] a={"船只",	"批量号",	"总段号",	"分段号",	"大组极重",	"总装部最新分段需求期",	"钢料需求",	"X大板",	"X数控件",	"X平铁",	"X压弯",	"X型材",	"X二次装T型材"};
//        String[] b={"船只",	"批量号",	"总段号",	"分段号",	"大组极重",	"钢料需求",	"D大板",	"D曲板",	"D型材T",	"D散件"};
//        String[] a1={"dcCh","dcPl",	"zdh","dcFd","dzjz","zxfdxq",	"glxq",	"xdb",	"xskj,",
//                "xpt,",	"xyw",	"xxc",	"xtxc",	};
//        String[] b1={"dcCh","dcPl","zdh","dcFd","dzjz","glxq",	"dqb",	"dxc",	"dsj",	"ddb"};
//        for (int i = 0; i < b.length; i++) {
//            System.out.println("{ field: '"+b1[i]+"', title: '"+b[i]+"', width: 120, \n" +
//                    " filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],\n" +
//                    " filterRender: { name: 'FilterCombination', },\n" +
//                    "},");
//        }

    }

}

