package com.dsic.gj_erp.service.jcsj.impl;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.dao.jcsj.EmGcrlRepository;
import com.dsic.gj_erp.mapper.jcsj.EmGcrlMapper;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import io.swagger.models.auth.In;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.Period;
import java.time.Year;
import java.time.format.DateTimeFormatter;
import java.time.temporal.WeekFields;
import java.util.*;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmGcrlServiceImpl extends ServiceImpl<EmGcrlMapper, EmGcrl> implements EmGcrlService {

    @Resource
    EmGcrlMapper emGcrlMapper;
    @Resource
    EmGcrlRepository emGcrlRepository;


    String[] weekArray = { "一", "二", "三", "四", "五", "六","日"};

    @Override
    public List<EmGcrl> getList(JSONObject json) {
        QueryWrapper<EmGcrl> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("nf"))){
            queryWrapper.eq("NF",json.getString("nf"));
        }else{
            queryWrapper.eq("NF", Calendar.getInstance().get(Calendar.YEAR));
        }
        queryWrapper.orderByDesc("gl");
        List<EmGcrl> emGcrls=emGcrlMapper.selectList(queryWrapper);
        return emGcrls;
    }



    @Override
    public void update(List<EmGcrl> emGcrls) {
     //   emGcrlRepository.saveAll(emGcrls);
        updateBatchById(emGcrls);
    }

    @Override
    public void generate(String nf) {
        List<EmGcrl> emGcrlRepositoryByNf=emGcrlRepository.findByNf(nf);
        if (ObjectUtil.isEmpty(emGcrlRepositoryByNf)){
            Integer intNF=Integer.parseInt(nf);
            LocalDate startDate = LocalDate.of(intNF, 1, 1); // 起始日期：2022年1月1日
            LocalDate endDate = LocalDate.of(intNF, 12, 31); // 结束日期：2022年12月31日
            List<EmGcrl> saveList=new ArrayList<>();
            LocalDate currentDate = startDate;

            while (currentDate.isBefore(endDate) || currentDate.isEqual(endDate)) {
                EmGcrl emGcrl=new EmGcrl();
                emGcrl.setNf(nf);
                String gl = currentDate.format(DateTimeFormatter.ofPattern("yyyy/MM/dd"));
                emGcrl.setGl(gl);
                WeekFields weekFields = WeekFields.of(Locale.getDefault());
                Integer weekOfYear = currentDate.get(weekFields.weekOfYear());
                emGcrl.setNz(weekOfYear.toString());
                Integer weekOfMonth = currentDate.get(weekFields.weekOfMonth());
                emGcrl.setYz(weekOfMonth.toString());
                DayOfWeek dayOfWeek = currentDate.getDayOfWeek();
                Integer dayOfYear= currentDate.getDayOfYear();
                emGcrl.setGzlr(dayOfYear.toString());
                Integer zj=dayOfWeek.getValue();
                emGcrl.setXq(weekArray[zj-1]);
                if(zj==6||zj==7){
                    emGcrl.setXxr("0");
                }else {
                    emGcrl.setXxr("1");
                }
                saveList.add(emGcrl);
                currentDate = currentDate.plusDays(1); // 增加一天，处理下一个日期
            }
            saveBatch(saveList);
        }
    }
}
