package com.dsic.gj_erp.service.jcsj.impl;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.mapper.jcsj.EmSbcnpMapper;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmSbcnpServiceImpl extends ServiceImpl<EmSbcnpMapper, EmSbcnp> implements EmSbcnpService {

    @Resource
    EmSbcnpMapper emSbcnpMapper;
//    @Resource
//    EmSbcnpRepository emSbcnpRepository;

    @Override
    public List<EmSbcnp> getList(JSONObject json) {
        QueryWrapper<EmSbcnp> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("sbmc"))){
            queryWrapper.eq("SBMC",json.getString("sbmc"));
        }
        if(StringUtils.isNotEmpty(json.getString("kw"))){
            queryWrapper.eq("KW",json.getString("kw"));
        }
//        if(StringUtils.isNotEmpty(json.getString("sbmc"))){
//            queryWrapper.eq("SBMC",json.getString("sbmc"));
//        }
        List<EmSbcnp> emSbjbbs=emSbcnpMapper.selectList(queryWrapper);
        return emSbjbbs;
    }

    @Override
    public void save(List<EmSbcnp> emSbcnps) {
        List<EmSbcnp> saveList= emSbcnps.stream().filter(emSbcnp -> StringUtils.isNotEmpty(emSbcnp.getSbbh())).collect(Collectors.toList());
        saveBatch(saveList);
    }

    @Override
    public void update(List<EmSbcnp> emSbcnps) {
        //emSbcnpRepository.saveAll(emSbcnps);
        updateBatchById(emSbcnps);
    }

    @Override
    public void delete(List<EmSbcnp> emSbcnps) {
    //    emSbcnpRepository.deleteAll(emSbcnps);
        List<String> idList=emSbcnps.stream().map(EmSbcnp::getSbbh).collect(Collectors.toList());
        emSbcnpMapper.deleteBatchIds(idList);
    }

}
