package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.util.ObjUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@Service
public class DmSygdxqServiceImpl extends ServiceImpl<DmSygdxqMapper, DmSygdxq> implements DmSygdxqService {

    @Override
    @Transactional
    public void saveXzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                l.setDrcs(sygdxq.getDrcs()+1);
                l.setXzglxqOld(sygdxq.getXzglxq());
                l.setDrr(username);
                l.setDrrq(day);
                //状态 2拖期 1提前
                if (l.getXzglxq().compareTo(sygdxq.getXzglxq())>0){
                    l.setXqzt("2");
                }
                if (l.getXzglxq().compareTo(sygdxq.getXzglxq())<0){
                    l.setXqzt("1");
                }
                this.update(new UpdateWrapper<DmSygdxq>()
                        .set("xzglxq",l.getXzglxq())
                        .set("xzglxq_old",l.getXzglxqOld())
                        .set("xdb",l.getXdb())
                        .set("xskj",l.getXskj())
                        .set("xpt",l.getXpt())
                        .set("xyw",l.getXyw())
                        .set("xxc",l.getXxc())
                        .set("xtxc",l.getXtxc())
                        .set("drcs",l.getDrcs())
                        .set("xqzt",l.getXqzt())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }


        });
    }

    @Override
    @Transactional
    public void saveDzList(List<DmSygdxq> list,String username,String day){
        list.forEach(l->{
            DmSygdxq sygdxq=this.getOne(new QueryWrapper<DmSygdxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(sygdxq)){
                l.setDrr(username);
                l.setDrrq(day);
                this.update(new UpdateWrapper<DmSygdxq>()
                        .set("dzglxq",l.getDzglxq())
                        .set("dzglxq_old",sygdxq.getDzglxq())
                        .set("dqb",l.getDqb())
                        .set("dxc",l.getDxc())
                        .set("dsj",l.getDsj())
                        .set("ddb",l.getDdb())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
        });
    }
}

