package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.util.ObjectUtil;
import cn.hutool.poi.excel.ExcelReader;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmJtsyjh;
import com.dsic.gj_erp.bean.jhgk.DmXbjh;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.mapper.jhgk.DmZrcjhMapper;
import com.dsic.gj_erp.service.jhgk.DmZrcjhService;
import com.dsic.gj_erp.util.ExcelUtil;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class DmZrcjhServiceImpl extends ServiceImpl<DmZrcjhMapper, DmZrcjh> implements DmZrcjhService {
    @Resource
    DmZrcjhMapper dmZrcjhMapper;
    @Resource
    ModelMapper modelMapper;

    @Override
    public List<DmZrcjh> getList(JSONObject json) {
        QueryWrapper<DmZrcjh> queryWrapper=new QueryWrapper<>();
//        if(StringUtils.isNotEmpty(json.getString("dcCh"))){
//            queryWrapper.eq("DC_CH",json.getString("dcCh"));
//        }
        if(StringUtils.isNotEmpty(json.getString("gjks"))){
            String time=json.getString("gjks");
            String startTime=time.split("~")[0];
            String endTime=time.split("~")[1];
            queryWrapper.between("gjks",startTime,endTime);
        }
        if(StringUtils.isNotEmpty(json.getString("Zt"))){
            queryWrapper.eq("zt",json.getString("Zt"));
        }
        queryWrapper.orderByAsc("DC_CH,cast(DC_PL as int)");
  //      queryWrapper.orderByAsc("DC_PL");
        List<DmZrcjh> dmZrcjhs=dmZrcjhMapper.selectList(queryWrapper);
        return dmZrcjhs;
    }

    @Override
    public List<DmZrcjh> upload(MultipartFile file) throws IOException {
        List<Map<String,Object>> list= ExcelUtil.readZRCJH(file);
        List<DmZrcjh> dmZrcjhs=new ArrayList<>();
        list.forEach(stringObjectMap -> {
            DmZrcjh dmZrcjh = modelMapper.map(stringObjectMap, DmZrcjh.class);
            dmZrcjh.setZt("0");
            dmZrcjhs.add(dmZrcjh);
        });
        return dmZrcjhs;
    }

    @Override
    public void save(HttpServletRequest req,List<DmZrcjh> dmZrcjhs) {
        String bzr= (String) req.getAttribute("yhms");
        Date date=new Date();

        List<DmZrcjh> saveDmzrcjhList=new ArrayList<>();
        SimpleDateFormat sdf= new SimpleDateFormat("yyyy/MM/dd");
        String day=sdf.format(date);
        dmZrcjhs.forEach(dmZrcjh -> {
            QueryWrapper<DmZrcjh> queryWrapper=new QueryWrapper<>();
            queryWrapper.eq("DC_CH",dmZrcjh.getDcCh());
            queryWrapper.eq("DC_PL",dmZrcjh.getDcPl());
            queryWrapper.eq("DC_FD",dmZrcjh.getDcFd());
            DmZrcjh dmZrcjhOne=dmZrcjhMapper.selectOne(queryWrapper);
            if (ObjectUtil.isNotEmpty(dmZrcjhOne)){
                String dmZrcjhOneBzr=dmZrcjhOne.getBzr();
                String dmZrcjhOneBzrq=dmZrcjhOne.getBzrq();
                if (dmZrcjhOneBzr.contains(bzr)){
                    String[] bzrStr=dmZrcjhOneBzr.split("@");
                    String[] bzrqStr=dmZrcjhOneBzrq.split("@");
                    boolean append=false;
                    for (int i=0;i<bzrqStr.length;i++){
                        if (bzrStr[i].equals(bzr)&&bzrqStr[i].equals(day)){
                            append=true;
                            break;
                        }
                    }
                    if (!append){
                        String appendBzr=(dmZrcjhOneBzr+"@"+bzr);
                        String appendBzrq=(dmZrcjhOneBzrq+"@"+day);
                        dmZrcjh.setBzr(appendBzr);
                        dmZrcjh.setBzrq(appendBzrq);
                        updateById(dmZrcjh);
                    }
                }
                else {
                    dmZrcjh.setBzr(dmZrcjhOneBzr+"@"+bzr);
                    dmZrcjh.setBzrq(dmZrcjhOneBzrq+"@"+day);
                    updateById(dmZrcjh);
                }
            }
            else {
                dmZrcjh.setBzr(bzr);
                dmZrcjh.setBzrq(day);
                saveDmzrcjhList.add(dmZrcjh);
            }
        });

        saveBatch(saveDmzrcjhList);

        List<List<DmZrcjh>> lists = Lists.partition(saveDmzrcjhList, 300);
        for (List<DmZrcjh> list:lists) {
            dmZrcjhMapper.updateCzplpNEW(list);
        }

    }

    @Override
    public void tj(List<DmZrcjh> dmZrcjhs) {
        dmZrcjhs.forEach(dmZrcjh -> {
            String zt=dmZrcjh.getZt();
            String setZt=zt.equals("1")?"0":"1";
            dmZrcjh.setZt(setZt);
        });
        updateBatchById(dmZrcjhs);
    }

    @Override
    public void sh(List<DmZrcjh> dmZrcjhs) {
        dmZrcjhs.forEach(dmZrcjh -> {
            dmZrcjh.setZt("2");
        });
        updateBatchById(dmZrcjhs);
    }
}
